@ Kim's Smoother @
@ This procedure requires the globals vei, nstat,terms,nrows @


proc(6) =emsmth(th,y);
 local  alpha1,alpha2,p,q,sig2,sig1,rho,pxp1,pxa1,pxpkim,lf,it,qq1,qq2,pth,qth,x,z;

@ Establish values of parameters @
   alpha1 = th[1:vei[1,1],1];
  alpha2 = th[1+vei[1,1]:vei[1,1]+vei[2,1],1];
  pth = th[1+sumc(vei[1:nstat,1]):sumc(vei[1:nstat,1])+vei[3,1],1];
  qth = th[1+sumc(vei[1:nstat+1,1]):sumc(vei[1:nstat+1,1])+vei[4,1],1];
  sig1 = abs(th[sumc(vei)+1,1]);
  if ix == 0;
    sig2 = sig1;
  else;
    sig2 = abs(th[sumc(vei)+2,1]);
  endif;
  lf = zeros(nrows,1);

@ Set the p and q for each period @

  p = cdfn(y[.,terms[nstat+1,1]:terms[nstat+1,2]]*pth);
  q = cdfn(y[.,terms[nstat+2,1]:terms[nstat+2,2]]*qth); 

@ Select the correct value of rho (prob of state 1 at time 0) @
  if iy == 0;             rho = (1-meanc(q))/(2-meanc(p)-meanc(q));
  elseif iy == 1;         rho = cdfn(th[sumc(vei)+2+ix,1]);
  elseif iy == 2;         rho = 1.0;
  elseif iy == 3;         rho = 0;
  endif;

@ Set PDF's of y for each regime @
  qq1 = pdfn((y[.,1]-y[.,terms[1,1]:terms[1,2]]*alpha1)/sig1)/sig1;
  qq2 = pdfn((y[.,1]-y[.,terms[2,1]:terms[2,2]]*alpha2)/sig2)/sig2;

    @ This allows for underflows in the above expression. @
    if ndpchk(3);   ndpclex;    endif;

@ Start the first loop @ 
/* This loop is the same as mksmooth.g except that we now store the values for pxa1 in a matrix */

pxp1=zeros(nrows,1);    lf=zeros(nrows,1);     pxa1=zeros(nrows,1);

if useDLL;
    dllcall mklz(p,q,qq1,qq2,nrows,rho,lf,pxa1,pxp1);

else;

    it = 1;     
    do until it > nrows;
      if it == 1;                  @ Step 1 : Ex Ante probability of State 1 @
        pxa1[it,1] = (1-q[it,1])*(1-rho) + p[it,1]*rho;
      else;
        pxa1[it,1] = (1-q[it,1])*(1-pxp1[it-1,1]) + p[it,1]*pxp1[it-1,1];
      endif;
      pxp1[it,1] = pxa1[it,1]*qq1[it,1]; @ Step 2 : Ex Post joint density of State 1 @
                                   @ Step 3 : Likelihood Function @
      lf[it,1] = pxp1[it,1]+(1-pxa1[it,1])*qq2[it,1];
                                   @ Step 4 : Ex Post probability of State 1 @
      pxp1[it,1] = pxp1[it,1]/lf[it,1];
      it = it+1;
    endo;

endif;
/*
    do until it > nrows;
      if it == 1;                  @ Step 1 : Ex Ante probability of State 1 @
        pxa1[it,1] = (1-q[it,1])*(1-rho) + p[it,1]*rho;
      else;
        pxa1[it,1] = (1-q[it,1])*(1-pxp1[it-1,1]) + p[it,1]*pxp1[it-1,1];
      endif;
      pxp1[it,1] = pxa1[it,1]*qq1[it,1]; @ Step 2 : Ex Post joint density of State 1 @
                                   @ Step 3 : Likelihood Function @
      lf[it,1] = pxp1[it,1]+(1-pxa1[it,1])*qq2[it,1];
                                   @ Step 4 : Ex Post probability of State 1 @
      pxp1[it,1] = pxp1[it,1]/lf[it,1];
    it = it+1;
    endo;
@ end of first loop @
*/
@Kim's Smoothing Algorithm Kim(1994)@
x = pxp1[1:nrows-1,.].*(p[2:nrows,.]./pxa1[2:nrows,.] - (1-p[2:nrows,.])./(1-pxa1[2:nrows,.]));
x = pxp1[nrows,.]|rev(x);  
z = pxp1[1:nrows-1,.].*(1-p[2:nrows,.])./(1-pxa1[2:nrows,.]);
z = zeros(1,1)|rev(z);
pxpkim = rev(recsercp(x,z));

retp(pxpkim,pxa1,pxp1,lf,p,q);                                                                                                   
             endp;


