clearg _emmaxit, _emconvg, _emecm, _emfull;

@ Set Defaults @
maxset;
_emmaxit=100;	@ Maximum number of EM iterations @
_emconvg=0.05;	@ EM Convergence criterion @
_emecm=0;	@ >0 will use swecmem, otherwise swem @

proc (5) = mcsw(b0,dta);
local newparam, oldparam, nparam, convcrit, iter, itertime;

@ The EM algorithm @
oldparam=b0;
convcrit = 1;
iter = 1;
nparam = rows(oldparam);
itertime = date;
do while convcrit>_emconvg and iter<=_emmaxit;
	if _emecm>0;
		newparam = swecmem(oldparam,dta);
	else;
		newparam = swem(oldparam,dta);
	endif;
	convcrit=(oldparam-newparam)./newparam;
@	convcrit=sqrt(convcrit'*convcrit/nparam);@
	convcrit=sqrt(maxc(convcrit.*convcrit));
	oldparam=newparam;
	iter=iter+1;
endo;
itertime=ethsec(itertime,date);
@ The MAXLIK algorithm @
if _emecm>0;
	_mlgdprc=&swecgrad;
	retp(maxlik(dta,0,&swecli,newparam));
else;
	_mlgdprc=&swgrad;
	retp(maxlik(dta,0,&swli,newparam));
endif;

endp;
